//+------------------------------------------------------------------+
//|                                          MarginReqForOpenPos.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern int type=1;
extern bool IBFX=false;
#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   if(type==1)
    start1(); 
   else if(type==2)
    start2();
   else if (type==3)
     start3(); 
//----
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                          SimplySpecification.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
string SymbolsArray[13] = {"","USDCHF","GBPUSD","EURUSD","USDJPY",
"AUDUSD","USDCAD","EURGBP","EURAUD","EURCHF","EURJPY","GBPJPY","GBPCHF"};
//+------------------------------------------------------------------+
//| string SymbolByNumber                                            |
//+------------------------------------------------------------------+
string GetSymbolString(int Number)
  {
//----
   string res = "";
   res = SymbolsArray[Number];   
//----
   return(res);
  }
//+------------------------------------------------------------------+
//| A very simple function to calculate margin for Forex symbols.    |
//| It automatically calculates in the account's base currency and   |
//| does not work for complicated rates that do not have direct      |
//| recalculation into the trade account's base currency.            |
//+------------------------------------------------------------------+
double MarginCalculate(string symbol,double volume)
  {
   string first   =StringSubstr(symbol,0,3);         // d ,    dd EUR
   string second  =StringSubstr(symbol,3,3);         // d ,    dd USD
   string currency=AccountCurrency();                // _ ,  dd USD
   double leverage=AccountLeverage();                // d ,  dd 100
   double contract=MarketInfo(symbol,MODE_LOTSIZE);  // dd d, dd 100000
   double bid     =MarketInfo(symbol,MODE_BID);      //  
//----   d d  XXXYYY
   if(StringLen(symbol)!=6)
     {
      Print("MarginCalculate: '",symbol,"' must be standard forex symbol XXXYYY");
      return(0.0);
     }
//---- dd  o
   if(bid<=0 || contract<=0) 
     {
      Print("MarginCalculate: no market information for '",symbol,"'");
      return(0.0);
     }
//---- dd  d d -  d
   if(first==currency)   return(contract*volume/leverage);           // USDxxx
   if(second==currency)  return(contract*bid*volume/leverage);       // xxxUSD
//---- dd  d,  d dd d _ 
   string base=currency+first;                                       // USDxxx
   if(MarketInfo(base,MODE_BID)>0) return(contract/MarketInfo(base,MODE_BID)*volume/leverage);
//---- d d
   base=first+currency;                                              // xxxUSD
   if(MarketInfo(base,MODE_BID)>0) return(contract*MarketInfo(base,MODE_BID)*volume/leverage);
//----   da dd
   Print("MarginCalculate: can not convert '",symbol,"'");
   return(0.0);
  }
  
double MarginCalculate_IBFX(string symbol,double volume)
  {
   string first   =StringSubstr(symbol,0,3);         
// ?????? ??????,    ???????? EUR
   string second  =StringSubstr(symbol,3,3);         
// ?????? ??????,    ???????? USD
   string currency=AccountCurrency();                
// ?????? ????????,  ???????? USD
   double leverage=AccountLeverage();                
// ????????? ?????,  ???????? 100
   double contract=MarketInfo(symbol,MODE_LOTSIZE);  
// ?????? ?????????, ???????? 100000
   double bid     =MarketInfo(symbol,MODE_BID);      
// ???? ???
//---- ????????? ?????? ??????????? ????????? ??????? XXXYYYm
   if(StringLen(symbol)!=7)
     {
      Print("MarginCalculate: '",symbol,
"' must be InterBankFX mini account forex symbol XXXYYYm");
      return(0.0);
     }
//---- ???????? ??????? ??????
   if(bid<=0 || contract<=0) 
     {
      Print("MarginCalculate: no market information for '",
            symbol,"'");
      return(0.0);
     }
//---- ????????? ????? ??????? ???????? - ??? ???????
   if(first==currency)   return(contract*volume/leverage);
// USDxxx
   if(second==currency)  return(contract*bid*volume/leverage);
// xxxUSD
//---- ????????? ??????? ??????, ???? ?????? ?????????????? 
//     ????? ?????? ????????
   //string base=currency+first;   
   string base=currency+first+"m";                           
// USDxxx
   if(MarketInfo(base,MODE_BID)>0) 
       return(contract/MarketInfo(base,MODE_BID)*volume/leverage);
//---- ????????? ????????
   base=first+currency+"m";
// xxxUSD
   if(MarketInfo(base,MODE_BID)>0) 
       return(contract*MarketInfo(base,MODE_BID)*volume/leverage);
//---- ??? ??????????? ??????? ???????????
   Print("MarginCalculate: can not convert '",symbol,"'");
   return(0.0);
  }  
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start1()
  {
    double margin1;
    
    if(IBFX==TRUE)
      margin1=MarginCalculate_IBFX(Symbol(),1);
    else  
      margin1=MarginCalculate(Symbol(),1);
     string MarginLevel;
   if (AccountMargin()>0) MarginLevel=StringConcatenate("\nMarginLevel=",DoubleToStr(AccountEquity()/AccountMargin()*100,2),"% ");
   else MarginLevel="\nMarginLevel=N/A";

//----
   //for(int i = 1; i < 13; i++)
   //  {
      Comment("");
      Comment(
        Symbol(),
        "\nAccountServer=",AccountServer(),        
        "\nAccountName=",AccountName(),
        "\nAccountNumber=",AccountNumber(),
        "\nAccountBalance=",AccountBalance(),
        "\nAccountCurrency=",AccountCurrency(),
        "\nAccountLeverage=",AccountLeverage(),
        //"\nAccountCredit=",AccountCredit(),
       MarginLevel,
        //"\nAccountStopoutLevel=",AccountStopoutLevel(),
        "\nAccountStopoutLevel=",AccountStopoutModeStr(),
        "\nAccountEquity=",AccountEquity(),
        "\nAccountFreeMargin=",AccountFreeMargin(),
        "\nAccountMargin=",AccountMargin(),
        "\nAccountFreeMarginMode=",AccountFreeMarginModeStr(),
        //"\nAccountFreeMarginCheck=",AccountFreeMarginCheck(),
        "\nAccountProfit=",AccountProfit(),
  
        "\nMODE_LOTSIZE=",MarketInfo(Symbol(), MODE_LOTSIZE),
        "\nMODE_LOTSTEP=",MarketInfo(Symbol(), MODE_LOTSTEP),
        "\nspread=",MarketInfo(Symbol(),MODE_SPREAD),
        "\nmargin at 1 lot=",margin1,
        "\nMODE_TICKVALUE=",MarketInfo(Symbol(),MODE_TICKVALUE),
        "\nMODE_TICKSIZE=",MarketInfo(Symbol(),MODE_TICKSIZE),

        //"\nMODE_DIGITS=",MarketInfo(Symbol(),MODE_DIGITS),
        //"\nMODE_LOTSIZE=",MarketInfo(Symbol(),MODE_LOTSIZE),
        "\nMODE_SWAPLONG=",MarketInfo(Symbol(),MODE_SWAPLONG),
        "\nMODE_SWAPSHORT=",MarketInfo(Symbol(),MODE_SWAPSHORT),               
        "\nMODE_STARTING=",MarketInfo(Symbol(),MODE_STARTING),        
        "\nMODE_EXPIRATION=",MarketInfo(Symbol(),MODE_EXPIRATION),                        
        "\nMODE_TRADEALLOWED=",MarketInfo(Symbol(),MODE_TRADEALLOWED),                        
        "\nMODE_MINLOT=",MarketInfo(Symbol(),MODE_MINLOT),                        
        //"\nMODE_LOTSTEP=",MarketInfo(Symbol(),MODE_LOTSTEP),                        
        "\nMODE_MAXLOT=",MarketInfo(Symbol(),MODE_MAXLOT),                        
        "\nMODE_MARGININIT=",MarketInfo(Symbol(),MODE_MARGININIT),                        
        "\nMODE_MARGINMAINTENANCE=",MarketInfo(Symbol(),MODE_MARGINMAINTENANCE),                        
        "\nMODE_MARGINHEDGED=",MarketInfo(Symbol(),MODE_MARGINHEDGED),                        
        "\nMODE_FREEZELEVEL=",MarketInfo(Symbol(),MODE_FREEZELEVEL),                                                                                
                
        "\nMODE_MARGINREQUIRED=",MarketInfo(Symbol(),MODE_MARGINREQUIRED)
        );
   //  } 
//----
   return(0);
  }
//+------------------------------------------------------------------+

string AccountStopoutModeStr()
{
int level=AccountStopoutLevel();
string s1;

  if (AccountStopoutMode()==0)
    s1=StringConcatenate("", level, "% (when the open positions are forcedly closed: percentage ratio between free margin and equity)");    
  else
    s1=StringConcatenate("", level, " ", AccountCurrency()," (when the open positions are forcedly closed: comparison of the free margin level to the absolute value)");
return(s1);
}

string AccountFreeMarginModeStr()
{
string s1;
//Calculation mode of free margin allowed to open positions on the current account. 
//The calculation mode can take the following values:
//0 - floating profit/loss is not used for calculation;
//1 - both floating profit and loss on open positions on the current account are used for free margin calculation;
//2 - only profit value is used for calculation, the current loss on open positions is not considered;
//3 - only loss value is used for calculation, the current loss on open positions is not considered.  

  if(AccountFreeMarginMode()==0)
     s1="floating profit/loss is not used for calculation";
  else if(AccountFreeMarginMode()==1)   
     s1="both floating profit and loss on open positions on the current account are used for free margin calculation";
  else if (AccountFreeMarginMode()==2)      
     s1="only profit value is used for calculation, the current loss on open positions is not considered";
  else if (AccountFreeMarginMode()==3)           
     s1="only loss value is used for calculation, the current loss on open positions is not considered.";  
  return(s1);   
}

//+------------------------------------------------------------------+
//|                                               accountdetails.mq4 |
//|                                           Copyright  2006, Iggy |
//|                                                 irusoh@yahoo.com |
//+------------------------------------------------------------------+
//#property copyright "Iggy"
//#property link      "irusoh@yahoo.com"
//----
//#include <WinUser32.mqh>
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start2()
  {
         string stm,ta;
         
   int nTradeAllowed;
   if(AccountStopoutMode() == 0)
             stm = "%";
   nTradeAllowed = MarketInfo(Symbol(), MODE_TRADEALLOWED);
         switch(nTradeAllowed)
           {
                case 0:    ta = "No";     break;
                case 1:    ta = "Yes";    break;
           }
           
         string msg = "Account Details:" + "\n" +
                      "  Number=" + AccountNumber() + "\n" +
                      "  Name=" + AccountName() + "\n" +
                      "  Currency=" + AccountCurrency() + "\n" +
                      "  Company=" + AccountCompany() + "\n" +
                      "  Server=" + AccountServer() + "\n" +
                   "  Leverage=" + AccountLeverage() + "\n" +
                      "  Stop Out level=" + AccountStopoutLevel() + stm + "\n" +
                      "  Balance Details:" + "\n" +
                      "  Balance=" + DoubleToStr(AccountBalance(), 4) + "\n" +
                      "  Equity=" + DoubleToStr(AccountEquity(), 4) + "\n" +
                      "  (Used)Margin=" + DoubleToStr(AccountMargin(), 4) + "\n" +
                      "  Free Margin=" + DoubleToStr(AccountFreeMargin(), 4) + "\n" +
                      "  Symbol Details:" + "\n" +
                      "  Symbol=" + Symbol() + "\n" +
                   "  Lot Size=" + DoubleToStr(MarketInfo(Symbol(), MODE_LOTSIZE),0) + 
                   "\n" +
                   "  Min Lot=" + DoubleToStr(MarketInfo(Symbol(), MODE_MINLOT), 2) + 
                   "\n" +
                   "  Lot Step=" + DoubleToStr(MarketInfo(Symbol(), MODE_LOTSTEP), 2) + 
                   "\n" +
                   "  Max Lot=" + DoubleToStr(MarketInfo(Symbol(), MODE_MAXLOT), 2) + 
                   "\n" +
                   "  Tick Value=" + DoubleToStr(MarketInfo(Symbol(), MODE_TICKVALUE), 4) + 
                   "\n" +
                   "  Tick Size=" + DoubleToStr(MarketInfo(Symbol(), MODE_TICKSIZE), Digits) + 
                   "\n"+
                   "  Spread=" + DoubleToStr(MarketInfo(Symbol(), MODE_SPREAD), 0) + 
                   "\n" +
                   "  Stop Loss Level=" + DoubleToStr(MarketInfo(Symbol(), MODE_STOPLEVEL), 0) +
                   "\n"+
                   "  Swap Long=" + DoubleToStr(MarketInfo(Symbol(), MODE_SWAPLONG), 4) + 
                   "\n" +
                   "  Swap Short=" + DoubleToStr(MarketInfo(Symbol(), MODE_SWAPSHORT), 4) + 
                   "\n" +
                   "  Initial Margin=" + DoubleToStr(MarketInfo(Symbol(), MODE_MARGININIT), 4) +
                   "\n" +
                   "  Maint Margin=" + DoubleToStr(MarketInfo(Symbol(), MODE_MARGINMAINTENANCE),
                   4) + "\n" +
                   "  Required Margin=" + DoubleToStr(MarketInfo(Symbol(), MODE_MARGINREQUIRED),
                   4) + "\n" +
                   "  Trade Allowed=" + ta + "\n";
      //MessageBox(msg, "Account/Symbol Details", 0);  
      Comment("");
      Comment(msg);
//----
   return(0);
  }
//+------------------------------------------------------------------+


int start3()
  {
//----
   
   string CommentString=StringConcatenate("\nAccount Number = ",AccountNumber(),"\n");
   CommentString=StringConcatenate(CommentString,"\nAccountCurrency=",AccountCurrency(),"\n");
   CommentString=StringConcatenate(CommentString,"\nAccountCompany=",AccountCompany(),"\n");
   CommentString=StringConcatenate(CommentString,"\nAccountName=",AccountName(),"\n");
   CommentString=StringConcatenate(CommentString,"\nAccountServer=",AccountServer(),"\n");
   CommentString=StringConcatenate(CommentString,"\nAccountStopoutLevel=",AccountStopoutLevel(),"\n");
   CommentString=StringConcatenate(CommentString,"\nAccountStopoutMode=",AccountStopoutMode(),"\n");
   CommentString=StringConcatenate(CommentString,"\nAccountBalance()=",AccountBalance(),"\n");
   CommentString=StringConcatenate(CommentString,"\nAccountMargin=",AccountMargin(),"\n");
   CommentString=StringConcatenate(CommentString,"\nAccountEquity=",AccountEquity(),"\n");
   
   string MarginLevel;
   if (AccountMargin()>0) MarginLevel=StringConcatenate("\nMarginLevel=",DoubleToStr(AccountEquity()/AccountMargin()*100,2),"% ");
   else MarginLevel="\nMarginLevel=N/A";
 
   CommentString=StringConcatenate(CommentString,MarginLevel);
   Comment(CommentString);
//----
   return(0);
  }

